<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "$theme/theme.php";
include_once "include/common.php";

$database   = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$manufacturer_filter = pg_escape_string($_REQUEST['filter']);
$film_id             = pg_escape_string($_REQUEST['item']);

/* Ensure the user owns it !*/
if ($po_user['type'] < $user_type['administrator']) {
  $result = pg_fetch_row(pg_query($database, "select count(identifier) from film where identifier=$film_id and users=$po_user[id]"));
  if ($result[0] == 0) {
    site_epilog($database);
    header("location: login.php");
    exit();
  }
 }

$film_current_value = pg_fetch_row(pg_query($database, "select name, model, iso, format, access_rights from view_film where identifier='$film_id'"));
$film_type_current_value = pg_fetch_row(pg_query($database, "select type from film where identifier='$film_id'"));

switch ($manufacturer_filter) {
 case 'All':
 case '':
   $all_film_types = pg_query($database, "select identifier, name, model, iso, format, url from view_film_type");
   break;
 default:
   $all_film_types = pg_query($database, "select identifier, name, model, iso, format, url from view_film_type where name='$manufacturer_filter' or identifier='$film_type_current_value[0]'");
}

site_header($page_width, "Edit Film");
site_navigator(6);
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.profile.php\">My Profile</a> : Edit film", "");

print "&nbsp;<br/>";
display_navigator_box_top($profile_data['film']['idx'], $profile_data, "100%");

print "&nbsp;<br/>";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"5\">\n";
print "<table width=\"100%\">\n<tr>\n";
print "<td align=\"left\"><font class=\"tabletop\">Film Types</font></td>\n";
print "<td align=\"right\" >\n";
print "<form>\n";
print "<select onchange=\"location = this.options[this.selectedIndex].value;\">\n";
print "<option value=\"film.edit.php\">All";
$all_manufacturer = pg_query($database, "select identifier, name from manufacturer");
$num_of_manufacturers = pg_num_rows($all_manufacturer);
for ($i=0; $i < $num_of_manufacturers; $i++) {
  $manufacturer = pg_fetch_row($all_manufacturer, $i);
  if ($manufacturer[1]==$manufacturer_filter)
    print "<option value=\"film.add.php?filter=$manufacturer[1]\" selected>$manufacturer[1]";
  else
    print "<option value=\"film.add.php?filter=$manufacturer[1]\">$manufacturer[1]";
}
print "</select>";
print "</form>\n";
print "</td></tr>\n</table>\n";
print "</td>";
print "</tr>";

print "<form method=\"post\" action=\"film.edit.2.php?item_id=$film_id\">";
print "<tr>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"4%\"></td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"44%\">Manufacturer</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Model</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"16%\">ISO</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"16%\">Format</td>\n";
print "</tr>\n";

$num_of_film_types = pg_num_rows($all_film_types);
if ($num_of_film_types > 0) {
  for ($i=0; $i < $num_of_film_types; $i++) {
    $film_type = pg_fetch_row($all_film_types, $i);
    print "<tr>";
    if ($film_type_current_value[0] == $film_type[0])
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"><input type=\"radio\" name=\"film_type_id\" value=\"$film_type[0]\" checked/></td>";
    else
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"><input type=\"radio\" name=\"film_type_id\" value=\"$film_type[0]\"/></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$film_type[5]\">$film_type[1]</a></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$film_type[2]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$film_type[3]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$film_type[4]</td>";
    print "</tr>";
  }
}
else
print "<tr><td colspan=5 align=\"left\" bgcolor=\"$color[table_body]\" >No film types found.</td></tr>";

print "</table>\n";

print "&nbsp;<br/>\n";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=6><font class=\"tabletop\">Edit Film Type</font></td>";
print "</td>";
print "</tr>";
print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"4%\"></td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"44%\">Manufacturer</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Model</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"16%\">ISO</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"16%\">Format</td>\n";
print "</tr>";

print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<input type=\"radio\" name=\"film_type_id\" value=\"custom\"/>";
print "</td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<select name=film_manufacturer_id>";
for ($i=0; $i < $num_of_manufacturers; $i++) {
  $manufacturer = pg_fetch_row($all_manufacturer, $i);
  if ($film_current_value[0]==$manufacturer[1])
    print "<option value=$manufacturer[0] selected>$manufacturer[1]";
  else
    print "<option value=$manufacturer[0]>$manufacturer[1]";
}
print "</select>";

print "</td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\"  >";
print "<input type=\"text\" name=\"film_model\" value=\"$film_current_value[1]\"/>";
print "</td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
print "<select name=\"film_iso\">";
$all_film_iso = pg_query($database, "select identifier, value from film_iso order by value");
$num_of_film_iso = pg_num_rows($all_film_iso);
for ($i=0; $i < $num_of_film_iso; $i++) {
  $film_iso = pg_fetch_row($all_film_iso, $i);
  if ($film_current_value[2]==$film_iso[1])
    print "<option value=\"$film_iso[0]\" selected>$film_iso[1]";
  else
    print "<option value=\"$film_iso[0]\">$film_iso[1]";
}
print "</select>";
print "</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_body]\"  ><select name=\"film_format_id\">\n";
$all_film_format = pg_query($database, "select identifier, value from film_format");
$num_of_film_format = pg_num_rows($all_film_format);
for ($i=0; $i < $num_of_film_format; $i++) {
  $film_format = pg_fetch_row($all_film_format, $i);
  if ($film_current_value[3] == $film_format[1])
    print "<option value=\"$film_format[0]\" selected>$film_format[1]";
  else
    print "<option value=\"$film_format[0]\">$film_format[1]";
}
print "</select></td>\n";
print "</tr>";
print "</table>\n";

print "&nbsp;<br/>\n";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr><td align=\"left\" bgcolor=\"$color[table_top]\"><font class=\"tabletop\">Film Specific Data</font></td></tr>";

print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_header]\" >Access</td>";
print "</tr>";

print "<tr>";
print "<td bgcolor=\"$color[table_body]\" >"; display_access_combo("film_access_rights", $film_current_value[4], ""); print "</td>\n";
print "</tr>";
print "</table>";

print "&nbsp;<br/>";
print "<input type=\"image\" src=\"$theme/button.save.changes.gif\" border=\"0\" value=\"Save Changes\"/>\n";
print "<a class=\"nodecor\" href=\"my.profile.php?selector=".$profile_data['film']['idx']."\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"/></a>\n";
print "</form>";

display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);
?>
