<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/common.php";
include_once "include/print.ps.php";
include_once "include/orderby.php";
include_once "include/site.php";

$database = site_prolog();

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$source_photo_id   = pg_escape_string($_REQUEST['source_photo']);
$source_folder_id  = pg_escape_string($_REQUEST['source_folder']);
$source_album_id   = pg_escape_string($_REQUEST['source_album']);
$print_type = $_REQUEST['print_type'];

if ($source_photo_id != "") {
  $photo_data_single = pg_fetch_row(pg_query($database, "select identifier, folder, caption, title from photo where identifier='$source_photo_id'"));
  $photo_data_single[2] = makeZanza($photo_data_single[3] ? $photo_data_single[3] : $photo_data_single[2], "No Title");
  $container_name = pg_fetch_row(pg_query($database, "select caption from folder where identifier=$photo_data_single[1]"));
  $container_name[0] = makeZanza($container_name[0], "No Caption");
  $navigator_status_message = "<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My folders and albums</a> : <a href=\"folder.php?folder=$photo_data_single[1]\">$container_name[0]</a> : <a href=\"photo.php?photo=$source_photo_id\">$photo_data_single[2]</a> : Preparing to print this picture ...";
  $print_message = "This photo has dupes, ";
} elseif ($source_album_id != "") {
  $container_name = pg_fetch_row(pg_query($database, "select caption from album where identifier='$source_album_id'"));
  $container_name[0] = makeZanza($container_name[0], "No Caption");
  $navigator_status_message = "<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My folders and albums</a> : <a href=\"album.php?album=$source_album_id\">$container_name[0]</a> : Preparing to print this album ...";
  $print_message = "Some photos in this album have dupes, ";
} elseif ($source_folder_id != "") {
  $container_name = pg_fetch_row(pg_query($database, "select caption from folder where identifier='$source_folder_id'"));
  $container_name[0] = makeZanza($container_name[0], "No Caption");
  $navigator_status_message = "<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My folders and albums</a> : <a href=\"folder.php?folder=$source_folder_id\">$container_name[0]</a> : Preparing to print this folder ...";
  $print_message = "Some photos in this folder have dupes, ";
}

$photos_in_spooler = pg_query($database, "select photo.identifier, photo.folder, photo.caption from photo_spooler, photo where photo.identifier=photo_spooler.photo and photo_spooler.users=$po_user[id]");
$my_printer_defaults = pg_fetch_row(pg_query($database, "select print_out, paper, label from preferences where preferences.identifier=$po_user[prefs]"));

site_header($page_width, "Print");
site_navigator(5);
site_navigator_status($navigator_status_message, "");

print "&nbsp;<br/>\n";
if ($print_type == "label") {
  $all_labels = pg_query($database, "
    select label.identifier,
           (select name from manufacturer where identifier=label.manufacturer),
           label.name, paper.name
      from label, paper
     where label.paper=paper.identifier");

  $label_id   = $_REQUEST['label'];

  if ($label_id == "")
    $label_id = $my_printer_defaults[2];

  $current_label = pg_fetch_row(pg_query($database, "
    select space_x, space_y, label.size_x, label.size_y, offset_x, offset_y, columns, rows, paper, paper.size_x, paper.size_y
      from label, paper
     where label.identifier=$label_id
       and label.paper=paper.identifier"));
  $x_space       = $current_label[0];
  $y_space       = $current_label[1];
  $x_size        = $current_label[2];
  $y_size        = $current_label[3];
  $left_margin   = $current_label[4];
  $right_margin  = $current_label[4];
  $top_margin    = $current_label[5];
  $bottom_margin = $current_label[5];
  $columns       = $current_label[6];
  $rows          = $current_label[7];

  $paper_name    = $current_label[ 8];
  $paper_width   = $current_label[ 9];
  $paper_height  = $current_label[10];

  print "<form>\n";
  print "<table width=\"100%\" >\n";
  print "<tr><td align=\"left\" valign=\"middle\" colspan=\"2\">\n";

  print "Label type:\n";
  if ($source_photo_id != "") {
    $argument = "source_photo";  $arg_value = "$source_photo_id";
  } elseif ($source_album_id != "") {
    $argument = "source_album";  $arg_value = "$source_album_id";
  } elseif ($source_folder_id != "") {
    $argument = "source_folder";  $arg_value = "$source_folder_id";
  }

  print "<select onchange=\"location = this.options[this.selectedIndex].value;\">\n";
  for ($i=0; $i < pg_num_rows($all_labels); $i++) {
    $labels = pg_fetch_row($all_labels, $i);
    if ($labels[0] == $label_id)
      print "<option value=\"print.php?label=$labels[0]&print_type=$print_type&$argument=$arg_value\" selected>$labels[1] $labels[2], $labels[3]";
    else
      print "<option value=\"print.php?label=$labels[0]&print_type=$print_type&$argument=$arg_value\">$labels[1] $labels[2], $labels[3]";

  }
  print "</select>";
  print "</form><br/>\n";

  print "</td></tr>\n";

  print "<tr><td colspan=2>\n";
  print "&nbsp;<br/>\n";
  print "<img src=\"$theme/line.horiz.gif\" height=\"2\" width=\"100%\"/>\n";
  print "<br/>&nbsp;\n";
  print "</td></tr>\n";

  print "<tr><td align=\"left\" valign=\"middle\" colspan=\"2\">\n";

  print "<form method=\"post\" action=\"print.2.php\">\n";
  display_label_layout($left_margin, $top_margin, $x_size, $y_size, $x_space, $y_space, $columns, $rows, TRUE);
  print "</td></tr>\n";
}
else {
  $all_papers = pg_query($database, "select identifier, name, size_x, size_y from paper");

  $paper_id   = $_REQUEST['paper'];

  if ($paper_id == "")
    $paper_id = $my_printer_defaults[1];

  $left_margin   = 20;
  $top_margin    = 20;
  $right_margin  = 20;
  $bottom_margin = 20;
  $columns       = 4;
  $x_space       = 5;
  $y_space       = 2;
  $x_size        = 0;
  $y_size        = 0;

  $current_paper = pg_fetch_row(pg_query($database, "select name, size_x, size_y from paper where identifier=$paper_id"));

  $paper_name    = $current_paper[0];
  $paper_width   = $current_paper[1];
  $paper_height  = $current_paper[2];

  print "<form>\n";
  print "<table width=\"100%\"  border=\"0\">\n";
  print "<tr><td align=\"left\" valign=\"middle\" colspan=\"2\">\n";
  print "Paper Size: &nbsp;\n";
  if ($source_photo_id != "") {
    $argument = "source_photo";  $arg_value = "$source_photo_id";
  } elseif ($source_album_id != "") {
    $argument = "source_album";  $arg_value = "$source_album_id";
  } elseif ($source_folder_id != "") {
    $argument = "source_folder";  $arg_value = "$source_folder_id";
  }
  print "<select onchange=\"location = this.options[this.selectedIndex].value;\">\n";
  for ($i=0; $i < pg_num_rows($all_papers); $i++) {
    $papers = pg_fetch_row($all_papers, $i);
    if ($papers[0] == $paper_id)
      print "<option value=\"print.php?paper=$papers[0]&print_type=$print_type&$argument=$arg_value\" selected>$papers[1]\n";
    else
      print "<option value=\"print.php?paper=$papers[0]&print_type=$print_type&$argument=$arg_value\">$papers[1]\n";
  }
  print "</select>\n";
  print "</form><br/>\n";
  print "</td></tr>\n";

  print "<tr><td colspan=\"2\">\n";
  print "&nbsp;<br/>\n";
  print "<img src=\"$theme/line.horiz.gif\" height=\"2\" width=\"100%\"/>\n";
  print "<br/>&nbsp;\n";
  print "</td></tr>\n";

  print "<tr><td>\n";

  print "<form method=\"post\" action=\"print.2.php\">\n";
  print "<input type=\"hidden\" name=\"x_space\" value=\"$x_space\"/>\n";
  print "<input type=\"hidden\" name=\"y_space\" value=\"$y_space\"/>\n";
  print "<input type=\"hidden\" name=\"x_size\"  value=\"$x_size\"/>\n";
  print "<input type=\"hidden\" name=\"y_size\"  value=\"$y_size\"/>\n";

  print "<table align=\"center\" border=\"0\" ><tr>\n";
  print "<td align=\"center\" colspan=\"3\">Margins</td><td>&nbsp;&nbsp;&nbsp;</td>\n";
  print "<td align=\"center\">Columns</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n";
  print "<td align=\"center\" colspan=\"2\">Spacing</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n";
  print "<td align=\"center\" colspan=\"3\">Orientation</td>\n";
  print "</tr><tr><td>";

  print "<tr>\n<td align=\"center\" colspan=\"3\">";
  print "<input type=\"text\" name=\"top_margin\" value=\"$top_margin\" size=\"4\"/></td><td></td>";
  print "<td align=\"center\" >";
  print "<select name=\"columns\">\n";
  for ($i=1; $i < 11; $i++) {
    if ($columns == $i)
      print "<option value=\"$i\" selected>$i";
    else
      print "<option value=\"$i\">$i";
  }
  print "</select>\n";
  print "</td>\n";
  print "<td></td>\n";
  print "<td></td>\n";
  print "<td align=\"center\"><input type=\"text\" name=\"x_space\" value=\"$x_space\" size=\"4\"/>\n</td>\n";
  print "<td></td>\n";
  print "<td align=\"center\"><input type=\"radio\" name=\"orientation\" value=\"0\" checked/>Portrait</td>\n";
  print "<td>&nbsp;</td>\n";
  print "<td align=\"center\"><input type=\"radio\" name=\"orientation\" value=\"1\"/>Landscape</td>\n";
  print "</tr>\n";

  print "<tr>\n<td align=\"center\">\n<input type=\"text\" name=\"left_margin\" value=\"$left_margin\" size=\"4\" align=\"right\"/>\n</td>\n";
  print "<td>\n<img src=\"themes/print.layout.gif\"/>\n</td>";
  print "<td align=\"center\">\n<input type=\"text\" name=\"right_margin\" value=\"$right_margin\" size=\"4\"/>\n</td>\n";

  print "<td></td>\n";
  print "<td><img src=\"themes/print.layout.4.gif\"/>\n</td>";
  print "<td></td>\n";
  print "<td><input type=\"text\" name=\"y_space\" value=\"$y_space\" size=\"4\" align=\"right\"/></td>\n";
  print "<td><img src=\"themes/print.layout.spacing.gif\"/>\n</td>";
  print "<td></td>\n";
  print "<td><img src=\"themes/print.orient.portrait.gif\"/></td>";
  print "<td></td>\n";

  print "<td><img src=\"themes/print.orient.landscape.gif\"/></td>";
  print "</tr>\n";
  print "<tr>\n<td align=\"center\" colspan=\"3\">\n<input type=\"text\" name=\"bottom_margin\" value=\"$bottom_margin\" size=\"4\"/>\n</td>\n";
  print "<td colspan=\"9\"></td>\n";
  print "</tr></table>\n";

  print "</td></tr>\n";
}

print "<tr><td colspan=\"2\">\n";
print "&nbsp;<br/>\n";
print "<img src=\"$theme/line.horiz.gif\" height=\"2\" width=\"100%\"/>\n";
print "<br/>&nbsp;\n";
print "</td></tr>\n";

print "<tr><td colspan=\"2\">\n";

print "Please select which of the following details you want to appear on the printout.<p>";

print "<table align=\"center\" border=\"0\"  width=\"100%\"><tr><td width=\"33%\">\n";
if ($print_type == "brochure") {
  print "<input type=\"checkbox\" name=\"display_image\"          checked/> Image<br/>\n";
}
print "<input type=\"checkbox\" name=\"display_barcode\"        checked/> Barcode<br/>\n";
print "<input type=\"checkbox\" name=\"display_title\"          checked/> Title<br/>\n";
print "<input type=\"checkbox\" name=\"display_caption\"        checked/> Caption<br/>\n";
print "<input type=\"checkbox\" name=\"display_location\"       checked/> Location<br/>\n";
print "<input type=\"checkbox\" name=\"display_copyright\"      checked/> Copyright<br/>\n";
print "</td><td width=\"33%\">";
print "<input type=\"checkbox\" name=\"display_camera\"         checked/> Camera<br/>\n";
print "<input type=\"checkbox\" name=\"display_camera_program\" checked/> Camera program<br/>\n";
print "<input type=\"checkbox\" name=\"display_camera_meter\"   checked/> Camera metering<br/>\n";
print "<input type=\"checkbox\" name=\"display_shutter\"        checked/> Shutter speed<br/>\n";
print "<input type=\"checkbox\" name=\"display_aperture\"       checked/> Aperture<br/>\n";
print "<input type=\"checkbox\" name=\"display_exp_comp\"       checked/> Exposure compensation<br/>\n";
print "</td><td width=\"33%\">";
print "<input type=\"checkbox\" name=\"display_focal_length\"   checked/> Focal Length<br/>\n";
print "<input type=\"checkbox\" name=\"display_flash_mode\"     checked/> Flash mode<br/>\n";
print "<input type=\"checkbox\" name=\"display_flash_comp\"     checked/> Flash Compensation<br/>\n";
print "<input type=\"checkbox\" name=\"display_iso\"            checked/> Film ISO<br/>\n";
print "<input type=\"checkbox\" name=\"display_iso_override\"   checked/> Film ISO Override<br/>\n";
print "</td></tr></table>\n";
print "</td></tr>\n";

print "<tr><td colspan=\"2\">\n";
print "&nbsp;<br/>\n";
print "<img src=\"$theme/line.horiz.gif\" height=\"2\" width=\"100%\"/>\n";
print "<br/>&nbsp;\n";
print "</td></tr>\n";
print "<tr><td colspan=\"2\">\n";

print "&nbsp;<br/>\n";
print "Output format: \n";
display_print_format_combo("output_format", $my_printer_defaults[0]);
print "&nbsp;&nbsp;&nbsp;&nbsp;Order by: \n";
display_order_by_combo(5);
print "</td></tr>\n";

print "<tr><td colspan=\"2\">\n";
print "&nbsp;<br/>\n";
print "<img src=\"$theme/line.horiz.gif\" height=\"2\" width=\"100%\"/>\n";
print "<br/>&nbsp;\n";
print "</td></tr>\n";

print "</table>\n";


if ($source_photo_id != "") {
  print "<input type=\"hidden\" name=\"source_photo\" value=\"$source_photo_id\"/>\n";
} elseif ($source_album_id != "") {
  print "<input type=\"hidden\" name=\"source_album\" value=\"$source_album_id\"/>\n";
} elseif ($source_folder_id != "") {
  print "<input type=\"hidden\" name=\"source_folder\" value=\"$source_folder_id\"/>\n";
}

$dupes_found = 0;

for ($photos=0; $photos < pg_num_rows($photos_in_spooler); $photos++) {
  $photo_identifier = pg_fetch_row($photos_in_spooler, $photos);
  $photo_dupes = pg_query($database, "select photo_dupe.identifier, photo_dupe.key, date_of_creation, storage_location, storage_index, remark from photo_dupe where photo=$photo_identifier[0] order by date_of_creation");
  if (pg_num_rows($photo_dupes) > 1) {
    if ($dupes_found == 0) {
      $dupes_found = 1;
      print "<table align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
      print "<tr><td align=\"left\"  colspan=\"2\">\n";
      print $print_message . "Please select which dupe would you like to print!<br/>&nbsp;";
      print "</td></tr>";
      print "</table>\n";
      print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
    }
    print "<tr><td align=\"left\" bgcolor=\"$color[table_header]\"  colspan=\"6\" >\n";
    print "<a href=\"folder.php?folder=$source_folder_id\">$container_name[0]</a>&nbsp;:&nbsp;";
    print "<a href=\"photo.php?photo=$photo_identifier[0]&detail_info=3\">$photo_identifier[2]</a>&nbsp;";
    print "</td></tr>";
    for ($dupes=0; $dupes < pg_num_rows($photo_dupes); $dupes++) {
      $photo_dupe_single = pg_fetch_row($photo_dupes, $dupes);
      print "<tr><td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"4%\">";
      print "<input type=\"checkbox\" name=\"pd$photo_dupe_single[0]\" checked/>";
      print "</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"14%\">$photo_identifier[0]-$photo_dupe_single[1]</td>";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"20%\">".generate_date_html($photo_dupe_single[2], 'date', 1)."</td>";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"15%\">$photo_dupe_single[5]</td>";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"15%\">$photo_dupe_single[3]:$photo_dupe_single[4]</td>";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"32%\">$photo_dupe_single[6]</td>";
      print "</td></tr>\n";
    }
  }
}

if ($dupes_found == 1) {
  print "</table>\n";
}

print "&nbsp;<br/>\n";
print "<table align=\"center\" ><tr><td align=\"center\">\n";
print "<input type=\"image\" src=\"$theme/button.print.gif\" border=\"0\" value=\"Print\"/>\n";
if ($source_photo_id != "") {
  print "<a class=\"nodecor\" href=\"photo.php?photo=$source_photo_id\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"/></a>\n";
} elseif ($source_album_id != "") {
  print "<a class=\"nodecor\" href=\"album.php?album=$source_album_id\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"/></a>\n";
} elseif ($source_folder_id != "") {
  print "<a class=\"nodecor\" href=\"folder.php?folder=$source_folder_id\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"/></a>\n";
}
print "</td></tr></table>\n";
print "<input type=\"hidden\" name=\"x_paper\"    value=\"$paper_width\"/>\n";
print "<input type=\"hidden\" name=\"y_paper\"    value=\"$paper_height\"/>\n";
print "<input type=\"hidden\" name=\"paper_name\" value=\"$paper_name\"/>\n";
print "<input type=\"hidden\" name=\"print_type\" value=\"$print_type\"/>\n";
print "</form>\n";


print "&nbsp;<br/>\n";

site_footer($database);
site_epilog($database);
?>
