<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/tools.php";
include_once "include/mime.php";
include_once "$theme/theme.php";
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog();

if ($po_user['id'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$select_folder   = pg_escape_string($_REQUEST['select_folder']);
if (!$select_folder) {
  /* return if no search criteria exists */
  header("location: my.tools.php?selector=2&rule=$rule_identifier");
}

$type = $_REQUEST['type'];
switch ($type) {
 case "layout":
   $index_algorithm = "ar_index_haar:0.2.0";
   break;
 case "color":
   $index_algorithm = "ar_index_histogram:0.1.0";
}

site_header($page_width, "Display Tools");
site_navigator(10);
site_navigator_status("<a href=\"user.php\">Users</a> : My Tools", "");

print "&nbsp;<br/>";
display_navigator_box_top($tools_data['content_indexer']['idx'], $tools_data, "100%");

if ($po_user['type'] < $user_type['administrator']) {
  $user_sel = " and users = $po_user[id]";
} else {
  $user_sel = "";
}

if ($select_folder == "all") {
  $sql_selector = " users = $po_user[id] ";
} else {
  $sql_selector = " folder = $select_folder $user_sel";
}

$all_photos = pg_query($database, "
  select identifier from photo
   where $sql_selector
     and access_rights = $access[public]");

$num_of_updates = pg_num_rows($all_photos);
for ($i=0; $i < $num_of_updates; $i++) {
  $photo = pg_fetch_row($all_photos, $i);
  submit_photo($database, $photo[0], $po_user['session'], $index_algorithm);
}

print "<p align=\"left\">Indexed $num_of_updates photos.</p>";

print "<p>";
print "<a class=\"nodecor\" href=\"my.tools.php?selector=5&rule=$rule_identifier\"><img src=\"$theme/button.back.gif\" border=\"0\"/></a>";
print "</p>";


display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);



?>
