<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "$theme/theme.php";
include_once "include/common.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$location_id = pg_escape_string($_REQUEST['item']);

$all_states = pg_query($database, "select identifier, value from state order by value");
$all_countries = pg_query($database, "select identifier, value from country order by value");

$location = pg_fetch_row(pg_query($database, "select place, city, state, country, latitude, longitude, private, users from location where identifier=$location_id"));


/* Ensure the user owns it !*/
if (($po_user['id'] != $location[7]) &&
    ($po_user['type'] < $user_type['administrator'])) {
  site_epilog($database);
  header("location: login.php");
  exit();
 }

site_header($page_width, "Edit Location");
site_navigator(8);
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.profile.php\">My Profile</a> : Edit Location", "");

print "&nbsp;<br/>";
display_navigator_box_top($profile_data['location']['idx'], $profile_data, "100%");

print "&nbsp;<br/>";
print "<form method=\"post\" action=\"location.edit.2.php\">";
print "<input type=\"hidden\" name=\"location\" value=\"$location_id\"/><p>";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Location</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">City</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"15%\">State</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Country</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Latitude</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Longitude</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5\">Private</td>\n";
print "</tr>";
print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><input type=\"text\" name=\"location_name\" value=\"$location[0]\" size=\"20%\"/></td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><input type=\"text\" name=\"location_city\" value=\"$location[1]\" size=\"20%\"/></td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_combo("location_state", $all_states, $location[2], "", 0); print"</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_combo("location_country", $all_countries, $location[3], "", 0); print"</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><input type=\"text\" name=\"location_latitude\"  value=\"$location[4]\" size=\"10%\"/></td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><input type=\"text\" name=\"location_longitude\" value=\"$location[5]\" size=\"10%\"/></td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_yes_no_combo("private", $location[6]);
print "</td>";
print "</tr>";
print "</table>";

print "&nbsp;<br/>";
print "<input type=\"image\" src=\"$theme/button.save.changes.gif\" border=\"0\" value=\"Save Changes\"/>";
print "<a class=\"nodecor\" href=\"my.profile.php?selector=".$profile_data['location']['idx']."\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"/></a>";
print "</form>";

display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);
?>
