<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "$theme/theme.php";
include_once "include/common.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$manufacturer_id=pg_escape_string($_REQUEST['item']);

/* Ensure the user owns it !*/
if ($po_user['type'] < $user_type['administrator']) {
  $result = pg_fetch_row(pg_query($database, "select count(identifier) from manufacturer where identifier=$manufacturer_id and users=$po_user[id]"));
  if ($result[0] == 0) {
    site_epilog($database);
    header("location: login.php");
    exit();
  }
 }

site_header($page_width, "Delete Manufacturer");
site_navigator(6);

$manufacturer = pg_fetch_row(pg_query($database, "select name, url from manufacturer where identifier='$manufacturer_id'"));
$number_of_references = pg_fetch_row(pg_query($database, "select number_of_manufacturer_ref($manufacturer_id)"));

switch ($number_of_references[0]) {
 case 0:
   site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.profile.php\">My Profile</a> : Delete manufacturer", "");
   break;
 case 1:
   site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.profile.php\">My Profile</a> : There is 1 reference to this manufacturer. Cannot remove.", "");
   break;
 default:
   site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.profile.php\">My Profile</a> : There are $number_of_references[0] references to this manufacturer. Cannot remove.", "");
}

print "&nbsp;<br/>";
display_navigator_box_top($profile_data['manufacturer']['idx'], $profile_data, "100%");

print "&nbsp;<br/>";
print "<form method=\"post\" action=\"manufacturer.del.2.php\">";
print "<input type=\"hidden\" name=\"manufacturer\" value=\"$manufacturer_id\"/><p>";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr>\n";
print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"2\"><font class=\"tabletop\">Remove Manufacturer</font></td>\n";
print "</td>\n";
print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"35%\">Name</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"65%\">URL</td>\n";
print "</tr>";
print "<tr>";
print "<td bgcolor=\"$color[table_body]\" >$manufacturer[0]</td>";
print "<td bgcolor=\"$color[table_body]\" ><a href=\"$manufacturer[1]\">$manufacturer[1]</a></td>";
print "</tr>";
print "</table>";

print "&nbsp;<br/>";
if ($number_of_references[0]==0) {
  print "<input type=\"image\" src=\"$theme/button.confirm.delete.gif\" border=\"0\" value=\"Confirm Delete\"/>";
  print "<a class=\"nodecor\" href=\"my.profile.php?selector=".$profile_data['manufacturer']['idx']."\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"/></a>";
}
else {
  print "<a class=\"nodecor\" href=\"my.profile.php?selector=".$profile_data['manufacturer']['idx']."\"><img src=\"$theme/button.back.gif\" border=\"0\" alt=\"Back\"/></a>\n";
}
print "</form>";

display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);
?>
